from json import JSONEncoder
import json
from datetime import datetime
from iip.TypeTranslatorToString import TypeTranslatorToString
import Registry
from datatypes.RoutingConnOut import RoutingConnOut
from datatypes.RoutingConnOutImpl import RoutingConnOutImpl

class RoutingConnOutEncoder(JSONEncoder):
    """JSON encoder class for RoutingConnOut.
    Generated by: EASy-Producer."""

    def default(self, o):
        """Provides access to the attributes in o.
        
        Parameters:
          - o -- the object to serialize
        Returns:
          dict
            the attributes
        """
        return o.__dict__
    

class RoutingConnOutSerializer(TypeTranslatorToString):
    """JSON transport serializer for RoutingConnOut.
       Generated by: EASy-Producer."""
                
    def __init__(self):
        """Initializes the transformer.""" 
        Registry.serializers["RoutingConnOut"] = self
        Registry.types[RoutingConnOut] = "RoutingConnOut"
        Registry.serializers["RoutingConnOutImpl"] = self # there is a serializer for the Impl
        Registry.types[RoutingConnOutImpl] = "RoutingConnOut" # the Impl maps back to the type name
    
    def readFrom(self, data: str) -> RoutingConnOut:
        """Turns bytes into a String.
        
        Parameters:
          - data -- the data string
        Returns:
          object
            the deserialized object
        """
    
        result = RoutingConnOutImpl()
        result.__dict__ = json.loads(data)
        return result

    def writeTo(self, source: RoutingConnOut) -> str:
        """Turns an object into a String.
        
        Parameters:
          - source -- the object
        Returns:
          bytes
            the serialized data string
        """
        
        return RoutingConnOutEncoder().encode(source).encode("UTF-8").decode()
        
RoutingConnOutSerializer()
